﻿Type=StaticCode
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim AppPM As AppPreferenceManager

#Region  - *** Initialize the settings - 
#Region Crypto! ------------------------
	Dim DB_PASSWORD As String				: DB_PASSWORD 			= "32741126a2741126b2741126c2741126d2741126"
#End Region
#End Region

End Sub

Public Sub Initialize As Boolean

	Try
		AppPM.Initialize
		ProgressDialogShow2("Settings ...", True)
		DoEvents

#Region SHA-512 ------------------------ 
		'Code:

		Dim hash() As Byte
		Dim saltpassword As String
		Dim saltpasswordbyte() As Byte
		Dim mdencrypt As MessageDigest
		Dim bc As ByteConverter

		saltpassword = DB_PASSWORD

		saltpasswordbyte = saltpassword.GetBytes("UTF8")
		hash = mdencrypt.GetMessageDigest(saltpasswordbyte, "SHA-512")
		DB_PASSWORD = bc.HexFromBytes(hash)
		Crypto.Initialize(DB_PASSWORD)
		#End Region

		If AppPM.settings.Size > 0 Then
			If AppPM.settings.Get("#11") Then File.Delete(File.DirInternal, "settings.cfg")
		End If

		If Not(File.Exists(File.DirInternal, "settings.cfg")) Then
			AppPM.settings.Initialize
			AppPM.settings.Put("#00", False)	'00 #01 Download English
			AppPM.settings.Put("#01", False)	'01 #01 Download French
			AppPM.settings.Put("#02", False)	'02 #01 Download German
			AppPM.settings.Put("#03", False)	'03 #01 Download Hebraic
			AppPM.settings.Put("#04", False)	'04 #01 Download Italian
			AppPM.settings.Put("#05", False)	'05 #01 Download Japanese
			AppPM.settings.Put("#06", False)	'06 #01 Download Polish
			AppPM.settings.Put("#07", False)	'07 #01 Download Russian
			AppPM.settings.Put("#08", False)	'08 #01 Download Slovak
			AppPM.settings.Put("#09", False)	'09 #01 Download Spanish
			AppPM.settings.Put("#10", 1    )	'10 #02 Set Language (0-Polish,1-English,2-More)
			AppPM.settings.Put("#11", False)	'11 #03 Set Default settings (no-cancel-YES)
			AppPM.settings.Put("#12","TESS")	'12 #04 InputDialog(edittext)
			AppPM.settings.Put("#13", ""   )	'13 #05 Change password(cancel-change&save password)
			AppPM.settings.Put("#14", False)	'14 #06 Unknown sources(allow-cancel-OK)
			If AppPM.GetAndroidUnknownSourceStatus = 0 Then
				AppPM.settings.Put("#15", False)'15 #07 ON | OFF (unknown sources)
			Else
				AppPM.settings.Put("#15", True)	'15 #07 ON | OFF (unknown sources)
			End If
			AppPM.settings.Put("#16", False)	'16 #08 ON | OFF (Language)
			AppPM.settings.Put("#17", False)	'17 #09 Checked Flash ON
			AppPM.settings.Put("#18", False)	'18 #10 Checked	Focus AUTO
			File.WriteMap(File.DirInternal, "settings.cfg", AppPM.settings)
			AppPM.accessed.Clear
			AppPM.accessed.Put("#00", True)		'00 #01..10 Accessed Items (enabled/disabled)
			AppPM.accessed.Put("#01", True)		'01
			AppPM.accessed.Put("#02", True)		'02
			AppPM.accessed.Put("#03", True)		'03
			AppPM.accessed.Put("#04", True)		'04
			AppPM.accessed.Put("#05", True)		'05
			AppPM.accessed.Put("#06", True)		'06
			AppPM.accessed.Put("#07", True)		'07
			AppPM.accessed.Put("#08", True)		'08
			AppPM.accessed.Put("#09", True)		'09
			File.WriteMap(File.DirInternal, "accessed.cfg", AppPM.accessed)
			If File.Exists(File.DirInternal, "eng.lng") Then File.Delete(File.DirInternal, "eng.lng")
			If Not(File.Exists(File.DirInternal, "eng.lng")) Then File.Copy(File.DirAssets, "algtess_eng.lng", File.DirInternal, "algtess_eng.lng")
		End If
		AppPM.Language.Initialize
		AppPM.settings.Initialize
		AppPM.accessed.Initialize
		AppPM.settings = AppPM.ReadMap(File.DirInternal, "settings.cfg")
		AppPM.accessed = AppPM.ReadMap(File.DirInternal, "accessed.cfg")
		Return ReadLanguage
	Catch
		If File.Exists(File.DirInternal,  "settings.cfg") Then
			File.Delete(File.DirInternal, "settings.cfg")
			File.Delete(File.DirInternal, "accessed.cfg")
		End If
		ProgressDialogHide
		Msgbox(LastException.Message, L(0,"A T T E N T I O N"))
	End Try
	Return False
End Sub

Public Sub ReadLanguage As Boolean
	Private sett As Int = AppPM.settings.Get("#10")
	
	Try
		DoEvents
		If File.Exists(File.DirInternal, "algtess_eng.lng") Then
			'writing the eng.lng
			Dim raf As RandomAccessFile
   			raf.Initialize(File.DirInternal, "eng.lng", False)
			AppPM.Language = File.ReadList(File.DirInternal, "algtess_eng.lng")
   			raf.WriteEncryptedObject(AppPM.Language, DB_PASSWORD, raf.CurrentPosition)
		    raf.Close
			File.Copy(File.DirInternal, "algtess_eng.lng", File.DirDefaultExternal, "unknown.lng")
		End If
		
		DoEvents
		AppPM.Language.Initialize
		Select sett
	  	  Case 0
			'reading the eng.lng
   			Dim raf As RandomAccessFile
   			raf.Initialize(File.DirInternal, "eng.lng", True)
   			AppPM.Language = raf.ReadEncryptedObject(DB_PASSWORD, raf.CurrentPosition)
   			raf.Close
	  	  Case Else
		  	File.WriteList(File.DirDefaultExternal, "unknown.lng", AppPM.Language)
		End Select
		ProgressDialogHide
		Return True
	Catch
		ProgressDialogHide
		Return False
	End Try
End Sub

Public Sub L(Key As Int, str As String) As String
	Try
		Return AppPM.Language.Get(Key)
	Catch
		Return str
	End Try
End Sub